<?php
    /*********************************************************************************
     * Zurmo is a customer relationship management program developed by
     * Zurmo, Inc. Copyright (C) 2017 Zurmo Inc.
     *
     * Zurmo is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Affero General Public License version 3 as published by the
     * Free Software Foundation with the addition of the following permission added
     * to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED WORK
     * IN WHICH THE COPYRIGHT IS OWNED BY ZURMO, ZURMO DISCLAIMS THE WARRANTY
     * OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
     *
     * Zurmo is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License for more
     * details.
     *
     * You should have received a copy of the GNU Affero General Public License along with
     * this program; if not, see http://www.gnu.org/licenses or write to the Free
     * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
     * 02110-1301 USA.
     *
     * You can contact Zurmo, Inc. with a mailing address at 27 North Wacker Drive
     * Suite 370 Chicago, IL 60606. or at email address contact@zurmo.com.
     *
     * The interactive user interfaces in original and modified versions
     * of this program must display Appropriate Legal Notices, as required under
     * Section 5 of the GNU Affero General Public License version 3.
     *
     * In accordance with Section 7(b) of the GNU Affero General Public License version 3,
     * these Appropriate Legal Notices must retain the display of the Zurmo
     * logo and Zurmo copyright notice. If the display of the logo is not reasonably
     * feasible for technical reasons, the Appropriate Legal Notices must display the words
     * "Copyright Zurmo Inc. 2017. All rights reserved".
     ********************************************************************************/

    class ConfigureModulesView extends GridView
    {
        protected $cssClasses =  array( 'AdministrativeArea' , 'TableOfContentsView' );

        public function __construct()
        {
            parent::__construct(1, 1);
            $this->setView(new ConfigureModulesMenuView(), 0, 0);
        }

        public function isUniqueToAPage()
        {
            return true;
        }

        protected function renderContent()
        {
            $content  = $this->renderBannerContent();
            $content .= parent::renderContent();
            return $content;
        }

        protected function renderBannerContent()
        {
            if (Yii::app()->edition != 'Community')
            {
                return;
            }
            $content  = ZurmoHtml::openTag('div', array('class' => 'get-pro-message'));
            $content .= ZurmoHtml::openTag('div');
            $content .= ZurmoHtml::openTag('h2');
            $content .= Zurmo::t('ZurmoModule', 'Achieve more with a Zurmo subscription');
            $content .= ZurmoHtml::closeTag('h2');
            $content .= ZurmoHtml::openTag('p');
            $content .= Zurmo::t('HomeModule', 'Get more features, proactive support, access ' .
                'to training and consulting, blazing fast hosting, ' .
                'and in-depth documentation with a Zurmo subscription.');
            $content .= ZurmoHtml::closeTag('p');
            $content .= '<a href="http://www.zurmo.com/needSupport.php?source=amenu" class="z-button"><span class="z-label">' . // Not Coding Standard
                        Zurmo::t('ZurmoModule', 'Learn More' . '</span></a>');
            $content .= ZurmoHtml::closeTag('div');
            $content .= ZurmoHtml::closeTag('div');
            return $content;
        }
    }
?>
