<?php
    /*********************************************************************************
     * Zurmo is a customer relationship management program developed by
     * Zurmo, Inc. Copyright (C) 2017 Zurmo Inc.
     *
     * Zurmo is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Affero General Public License version 3 as published by the
     * Free Software Foundation with the addition of the following permission added
     * to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED WORK
     * IN WHICH THE COPYRIGHT IS OWNED BY ZURMO, ZURMO DISCLAIMS THE WARRANTY
     * OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
     *
     * Zurmo is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License for more
     * details.
     *
     * You should have received a copy of the GNU Affero General Public License along with
     * this program; if not, see http://www.gnu.org/licenses or write to the Free
     * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
     * 02110-1301 USA.
     *
     * You can contact Zurmo, Inc. with a mailing address at 27 North Wacker Drive
     * Suite 370 Chicago, IL 60606. or at email address contact@zurmo.com.
     *
     * The interactive user interfaces in original and modified versions
     * of this program must display Appropriate Legal Notices, as required under
     * Section 5 of the GNU Affero General Public License version 3.
     *
     * In accordance with Section 7(b) of the GNU Affero General Public License version 3,
     * these Appropriate Legal Notices must retain the display of the Zurmo
     * logo and Zurmo copyright notice. If the display of the logo is not reasonably
     * feasible for technical reasons, the Appropriate Legal Notices must display the words
     * "Copyright Zurmo Inc. 2017. All rights reserved".
     ********************************************************************************/

    /**
     * Base View for showing a selection of 'type'.  Workflow and Reporting for example extend this class
     */
    abstract class WizardTypeView extends MetadataView
    {
        /**
         * @return array
         */
        abstract protected function getTypeData();

        /**
         * @return string
         */
        protected function renderContent()
        {
            $content  = $this->renderTitleContent();
            $categoryData = $this->getTypeData();
            foreach ($categoryData as $notUsed => $categoryItems)
            {
                $content .= $this->renderMenu($categoryItems);
            }
            return $content;
        }

        /**
         * @param array $items
         * @return string
         */
        protected function renderMenu($items)
        {
            $content = '<ul class="configuration-list creation-list">';
            foreach ($items as $item)
            {
                $content .= '<li>';
                $content .= '<h4>' . $item['titleLabel'] . '</h4>';
                if (isset($item['descriptionLabel']))
                {
                    $content .= ' - ' . $item['descriptionLabel'];
                }
                $content .= ZurmoHtml::link(ZurmoHtml::tag('span', array('class' => 'z-label'), $this->getLinkText()),
                                        Yii::app()->createUrl($item['route']), array('class' => 'white-button'));
                $content .= '</li>';
            }
            $content .= '</ul>';
            return $content;
        }

        /**
         * @param $text
         */
        protected function setLinkText($text)
        {
            $this->linkText = $text;
        }

        /**
         * @return string
         */
        protected function getLinkText()
        {
            return Zurmo::t('Core', 'Create');
        }
    }
?>